Index: XIOS/trunk/src/interface/fortran_attr/iinterpolate_domain_attr.F90
===================================================================
--- XIOS/trunk/src/interface/fortran_attr/iinterpolate_domain_attr.F90	(revision 1014)
+++ XIOS/trunk/src/interface/fortran_attr/iinterpolate_domain_attr.F90	(revision 1040)
@@ -12,10 +12,9 @@
 
   SUBROUTINE xios(set_interpolate_domain_attr)  &
-    ( interpolate_domain_id, file, mode, order, renormalize, weight_filename, write_weight )
+    ( interpolate_domain_id, mode, order, renormalize, weight_filename, write_weight )
 
     IMPLICIT NONE
       TYPE(txios(interpolate_domain))  :: interpolate_domain_hdl
       CHARACTER(LEN=*), INTENT(IN) ::interpolate_domain_id
-      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: file
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: mode
       INTEGER  , OPTIONAL, INTENT(IN) :: order
@@ -29,14 +28,13 @@
       (interpolate_domain_id,interpolate_domain_hdl)
       CALL xios(set_interpolate_domain_attr_hdl_)   &
-      ( interpolate_domain_hdl, file, mode, order, renormalize, weight_filename, write_weight )
+      ( interpolate_domain_hdl, mode, order, renormalize, weight_filename, write_weight )
 
   END SUBROUTINE xios(set_interpolate_domain_attr)
 
   SUBROUTINE xios(set_interpolate_domain_attr_hdl)  &
-    ( interpolate_domain_hdl, file, mode, order, renormalize, weight_filename, write_weight )
-
-    IMPLICIT NONE
-      TYPE(txios(interpolate_domain)) , INTENT(IN) :: interpolate_domain_hdl
-      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: file
+    ( interpolate_domain_hdl, mode, order, renormalize, weight_filename, write_weight )
+
+    IMPLICIT NONE
+      TYPE(txios(interpolate_domain)) , INTENT(IN) :: interpolate_domain_hdl
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: mode
       INTEGER  , OPTIONAL, INTENT(IN) :: order
@@ -48,15 +46,13 @@
 
       CALL xios(set_interpolate_domain_attr_hdl_)  &
-      ( interpolate_domain_hdl, file, mode, order, renormalize, weight_filename, write_weight )
+      ( interpolate_domain_hdl, mode, order, renormalize, weight_filename, write_weight )
 
   END SUBROUTINE xios(set_interpolate_domain_attr_hdl)
 
   SUBROUTINE xios(set_interpolate_domain_attr_hdl_)   &
-    ( interpolate_domain_hdl, file_, mode_, order_, renormalize_, weight_filename_, write_weight_  &
-     )
-
-    IMPLICIT NONE
-      TYPE(txios(interpolate_domain)) , INTENT(IN) :: interpolate_domain_hdl
-      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: file_
+    ( interpolate_domain_hdl, mode_, order_, renormalize_, weight_filename_, write_weight_ )
+
+    IMPLICIT NONE
+      TYPE(txios(interpolate_domain)) , INTENT(IN) :: interpolate_domain_hdl
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: mode_
       INTEGER  , OPTIONAL, INTENT(IN) :: order_
@@ -67,9 +63,4 @@
       LOGICAL (KIND=C_BOOL) :: write_weight__tmp
 
-      IF (PRESENT(file_)) THEN
-        CALL cxios_set_interpolate_domain_file &
-      (interpolate_domain_hdl%daddr, file_, len(file_))
-      ENDIF
-
       IF (PRESENT(mode_)) THEN
         CALL cxios_set_interpolate_domain_mode &
@@ -102,10 +93,9 @@
 
   SUBROUTINE xios(get_interpolate_domain_attr)  &
-    ( interpolate_domain_id, file, mode, order, renormalize, weight_filename, write_weight )
+    ( interpolate_domain_id, mode, order, renormalize, weight_filename, write_weight )
 
     IMPLICIT NONE
       TYPE(txios(interpolate_domain))  :: interpolate_domain_hdl
       CHARACTER(LEN=*), INTENT(IN) ::interpolate_domain_id
-      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: file
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: mode
       INTEGER  , OPTIONAL, INTENT(OUT) :: order
@@ -119,14 +109,13 @@
       (interpolate_domain_id,interpolate_domain_hdl)
       CALL xios(get_interpolate_domain_attr_hdl_)   &
-      ( interpolate_domain_hdl, file, mode, order, renormalize, weight_filename, write_weight )
+      ( interpolate_domain_hdl, mode, order, renormalize, weight_filename, write_weight )
 
   END SUBROUTINE xios(get_interpolate_domain_attr)
 
   SUBROUTINE xios(get_interpolate_domain_attr_hdl)  &
-    ( interpolate_domain_hdl, file, mode, order, renormalize, weight_filename, write_weight )
-
-    IMPLICIT NONE
-      TYPE(txios(interpolate_domain)) , INTENT(IN) :: interpolate_domain_hdl
-      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: file
+    ( interpolate_domain_hdl, mode, order, renormalize, weight_filename, write_weight )
+
+    IMPLICIT NONE
+      TYPE(txios(interpolate_domain)) , INTENT(IN) :: interpolate_domain_hdl
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: mode
       INTEGER  , OPTIONAL, INTENT(OUT) :: order
@@ -138,15 +127,13 @@
 
       CALL xios(get_interpolate_domain_attr_hdl_)  &
-      ( interpolate_domain_hdl, file, mode, order, renormalize, weight_filename, write_weight )
+      ( interpolate_domain_hdl, mode, order, renormalize, weight_filename, write_weight )
 
   END SUBROUTINE xios(get_interpolate_domain_attr_hdl)
 
   SUBROUTINE xios(get_interpolate_domain_attr_hdl_)   &
-    ( interpolate_domain_hdl, file_, mode_, order_, renormalize_, weight_filename_, write_weight_  &
-     )
-
-    IMPLICIT NONE
-      TYPE(txios(interpolate_domain)) , INTENT(IN) :: interpolate_domain_hdl
-      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: file_
+    ( interpolate_domain_hdl, mode_, order_, renormalize_, weight_filename_, write_weight_ )
+
+    IMPLICIT NONE
+      TYPE(txios(interpolate_domain)) , INTENT(IN) :: interpolate_domain_hdl
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: mode_
       INTEGER  , OPTIONAL, INTENT(OUT) :: order_
@@ -157,9 +144,4 @@
       LOGICAL (KIND=C_BOOL) :: write_weight__tmp
 
-      IF (PRESENT(file_)) THEN
-        CALL cxios_get_interpolate_domain_file &
-      (interpolate_domain_hdl%daddr, file_, len(file_))
-      ENDIF
-
       IF (PRESENT(mode_)) THEN
         CALL cxios_get_interpolate_domain_mode &
@@ -192,11 +174,9 @@
 
   SUBROUTINE xios(is_defined_interpolate_domain_attr)  &
-    ( interpolate_domain_id, file, mode, order, renormalize, weight_filename, write_weight )
+    ( interpolate_domain_id, mode, order, renormalize, weight_filename, write_weight )
 
     IMPLICIT NONE
       TYPE(txios(interpolate_domain))  :: interpolate_domain_hdl
       CHARACTER(LEN=*), INTENT(IN) ::interpolate_domain_id
-      LOGICAL, OPTIONAL, INTENT(OUT) :: file
-      LOGICAL(KIND=C_BOOL) :: file_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: mode
       LOGICAL(KIND=C_BOOL) :: mode_tmp
@@ -213,15 +193,13 @@
       (interpolate_domain_id,interpolate_domain_hdl)
       CALL xios(is_defined_interpolate_domain_attr_hdl_)   &
-      ( interpolate_domain_hdl, file, mode, order, renormalize, weight_filename, write_weight )
+      ( interpolate_domain_hdl, mode, order, renormalize, weight_filename, write_weight )
 
   END SUBROUTINE xios(is_defined_interpolate_domain_attr)
 
   SUBROUTINE xios(is_defined_interpolate_domain_attr_hdl)  &
-    ( interpolate_domain_hdl, file, mode, order, renormalize, weight_filename, write_weight )
-
-    IMPLICIT NONE
-      TYPE(txios(interpolate_domain)) , INTENT(IN) :: interpolate_domain_hdl
-      LOGICAL, OPTIONAL, INTENT(OUT) :: file
-      LOGICAL(KIND=C_BOOL) :: file_tmp
+    ( interpolate_domain_hdl, mode, order, renormalize, weight_filename, write_weight )
+
+    IMPLICIT NONE
+      TYPE(txios(interpolate_domain)) , INTENT(IN) :: interpolate_domain_hdl
       LOGICAL, OPTIONAL, INTENT(OUT) :: mode
       LOGICAL(KIND=C_BOOL) :: mode_tmp
@@ -236,16 +214,13 @@
 
       CALL xios(is_defined_interpolate_domain_attr_hdl_)  &
-      ( interpolate_domain_hdl, file, mode, order, renormalize, weight_filename, write_weight )
+      ( interpolate_domain_hdl, mode, order, renormalize, weight_filename, write_weight )
 
   END SUBROUTINE xios(is_defined_interpolate_domain_attr_hdl)
 
   SUBROUTINE xios(is_defined_interpolate_domain_attr_hdl_)   &
-    ( interpolate_domain_hdl, file_, mode_, order_, renormalize_, weight_filename_, write_weight_  &
-     )
-
-    IMPLICIT NONE
-      TYPE(txios(interpolate_domain)) , INTENT(IN) :: interpolate_domain_hdl
-      LOGICAL, OPTIONAL, INTENT(OUT) :: file_
-      LOGICAL(KIND=C_BOOL) :: file__tmp
+    ( interpolate_domain_hdl, mode_, order_, renormalize_, weight_filename_, write_weight_ )
+
+    IMPLICIT NONE
+      TYPE(txios(interpolate_domain)) , INTENT(IN) :: interpolate_domain_hdl
       LOGICAL, OPTIONAL, INTENT(OUT) :: mode_
       LOGICAL(KIND=C_BOOL) :: mode__tmp
@@ -259,10 +234,4 @@
       LOGICAL(KIND=C_BOOL) :: write_weight__tmp
 
-      IF (PRESENT(file_)) THEN
-        file__tmp = cxios_is_defined_interpolate_domain_file &
-      (interpolate_domain_hdl%daddr)
-        file_ = file__tmp
-      ENDIF
-
       IF (PRESENT(mode_)) THEN
         mode__tmp = cxios_is_defined_interpolate_domain_mode &
Index: XIOS/trunk/src/interface/fortran_attr/interpolate_domain_interface_attr.F90
===================================================================
--- XIOS/trunk/src/interface/fortran_attr/interpolate_domain_interface_attr.F90	(revision 1014)
+++ XIOS/trunk/src/interface/fortran_attr/interpolate_domain_interface_attr.F90	(revision 1040)
@@ -9,25 +9,4 @@
   INTERFACE
     ! Do not call directly / interface FORTRAN 2003 <-> C99
-
-    SUBROUTINE cxios_set_interpolate_domain_file(interpolate_domain_hdl, file, file_size) BIND(C)
-      USE ISO_C_BINDING
-      INTEGER (kind = C_INTPTR_T), VALUE :: interpolate_domain_hdl
-      CHARACTER(kind = C_CHAR)    , DIMENSION(*) :: file
-      INTEGER  (kind = C_INT)     , VALUE        :: file_size
-    END SUBROUTINE cxios_set_interpolate_domain_file
-
-    SUBROUTINE cxios_get_interpolate_domain_file(interpolate_domain_hdl, file, file_size) BIND(C)
-      USE ISO_C_BINDING
-      INTEGER (kind = C_INTPTR_T), VALUE :: interpolate_domain_hdl
-      CHARACTER(kind = C_CHAR)    , DIMENSION(*) :: file
-      INTEGER  (kind = C_INT)     , VALUE        :: file_size
-    END SUBROUTINE cxios_get_interpolate_domain_file
-
-    FUNCTION cxios_is_defined_interpolate_domain_file(interpolate_domain_hdl) BIND(C)
-      USE ISO_C_BINDING
-      LOGICAL(kind=C_BOOL) :: cxios_is_defined_interpolate_domain_file
-      INTEGER (kind = C_INTPTR_T), VALUE :: interpolate_domain_hdl
-    END FUNCTION cxios_is_defined_interpolate_domain_file
-
 
     SUBROUTINE cxios_set_interpolate_domain_mode(interpolate_domain_hdl, mode, mode_size) BIND(C)